findU2d <- function(NPmle, ConfInt, LogLikfn, dataMat)
{
#### If saving memory space is not the top priority, and search 10 by 10 trials are OK, this is the function.
#### NPmle:  should be a vector of length 2, they are the NPmle of beta1 and beta2.
#### ConfInt:  should be a vector of length 2 .... the aprox. length of two 90% confidence intervals
#### for beta1, beta2. They do not have to be exact. But they provides good initial step.
#### LogLikfn:  is a function that takes two inputs: para + dataMat, and returns the loglik value
#### dataMat:  is only used for the function LogLikfn( ).
####
#### Output:  The beta1 and beta2, with beta1 maxed inside 95 percent contour. and Loglik value.

    MaxValue <- LogLikfn(NPmle, dataMat)$Loglik  
    stepsize <- ConfInt/3
    b1vec <- NPmle[1] + stepsize[1] * (1:10 - 5.5)   ### pertubations, 10 by 10 or others.
    b2vec <- NPmle[2] + stepsize[2] * (1:10 - 5.5)
    
    temp <- matrix(NA, nrow = 4, ncol = 100)
    temp[1, ] <- rep(b1vec, each=10)
    temp[2, ] <- rep(b2vec, times=10)
    
    for (i in 1:10) for (j in 1:10) {
         ind <- (i - 1) * 10 + j
         temp[4, ind] <- LogLikfn(mle=c(b1vec[i],b2vec[j]),dataMat)$Loglik
         temp[3, ind] <- b1vec[i]
    }

    subsetInd <- ( temp[4, ] >= (MaxValue - 3.84/2))
    ParaTrials <- temp[, subsetInd] 
    TrialValues <- ParaTrials[3,]

    maxInd <- which.max(TrialValues)
    Ub1 <- TrialValues[maxInd]
    maxPara <- ParaTrials[, maxInd]     #### this can be omitt. Ub1 should= ParaTrials[1,maxInd]
    print(c(Ub1, maxPara))

    for (N in 1:25){                #### may be more steps?
        if( abs(Ub1 - mean(b1vec)) < 4*min(stepsize) ) stepsize <- stepsize/2         ####
        b1vec <- maxPara[1] + stepsize[1]*(1:10 - 5.5)
        b2vec <- maxPara[2] + stepsize[2]*(1:10 - 5.5)
        
        temp[1, ] <- rep(b1vec, each=10)
        temp[2, ] <- rep(b2vec, times=10)
        
     for (i in 1:10) for (j in 1:10) {
            ind <- (i-1)*10 + j
            temp[4, ind] <- LogLikfn(mle=c(b1vec[i], b2vec[j]), dataMat)$Loglik
            temp[3, ind] <- b1vec[i]
        }
        subsetInd <- (temp[4, ] >= (MaxValue - 3.84/2))
        ParaTrials <- temp[, subsetInd]
        TrialValues <- ParaTrials[3,]
        maxInd <- which.max(TrialValues)
        Ub1 <- TrialValues[maxInd]
        maxPara <- ParaTrials[, maxInd]
        print(c(Ub1, maxPara))
    }
    list(Upper = Ub1, maxParameterNloglik = maxPara)
}